﻿Imports System
Imports System.IO
Imports System.Xml.Linq
Imports System.Text.RegularExpressions

Module Module1

Private Function HasWord(Word As String,
                    WordDetailList As List(Of WordDetail)) As Boolean
  For Each wd In WordDetailList
    If wd.Word = Word Then
      Return True
    End If
  Next
  Return False
End Function

Private Sub AddWordDetail(Word As String,
          ByRef WordDetailList As List(Of WordDetail))
  WordDetailList.Add(New WordDetail(Word, 1))
End Sub

Private Sub UpdateWordDetail(Word As String,
          ByRef WordDetailList As List(Of WordDetail))
  For Each wd In WordDetailList
    If wd.Word = Word Then
      wd.Frequency = wd.Frequency + 1
      Exit For
    End If
  Next
End Sub

Private Sub SortWordDetailListByFrequency(ByRef WordDetailList As  _
                                          List(Of WordDetail))
  WordDetailList = WordDetailList.OrderBy(Function(x) x.Frequency).ToList()
End Sub

Sub Main(ByVal args() As String)
  Dim ContentFolder = args(0)
  Dim AutoIndexSetFilePath = args(1)
  Dim WordDetailList As List(Of WordDetail) = New List(Of WordDetail)
  Dim DirInfo As New DirectoryInfo(ContentFolder)
  Dim FilesArray As FileInfo() = DirInfo.GetFiles()
  For Each f In FilesArray
    If f.Extension.Equals(".htm") Then
      Dim Topic As XDocument = XDocument.Load(f.FullName)
      Dim TopicTextString As String = Topic.Root.Element("body").Value
      TopicTextString = Regex.Replace(TopicTextString, "[^\w\.@-]", " ")
      Dim TopicText = TopicTextString.ToCharArray
      Dim NotDone As Boolean = True
      Dim StartIndex As Integer = 0
      Dim CurrentIndex = 0
      Dim EndIndex As Integer = 0
      If TopicText.Length = 0 Then
        NotDone = False
      End If
      While NotDone And CurrentIndex < TopicText.Length
        If Char.IsWhiteSpace(TopicText(CurrentIndex)) Then
          StartIndex = CurrentIndex
          CurrentIndex = CurrentIndex + 1
        Else
          Dim NotFound As Boolean = True
          While NotDone And CurrentIndex < TopicText.Length And _
              NotFound
            If Char.IsWhiteSpace(TopicText(CurrentIndex)) Or _
                                 CurrentIndex = TopicText.Length Then
              If CurrentIndex = TopicText.Length Then
                NotDone = False
              End If
              EndIndex = CurrentIndex
              Dim Word As String = ""
              Dim WordArray(EndIndex - StartIndex) As Char
              Array.Copy(TopicText, StartIndex,
                         WordArray, 0, EndIndex - StartIndex)
              Word = New String(WordArray)
              Word = Regex.Replace(Word, "[^\w\.@-]", "")
              If Word.LastIndexOf(".") = Word.Length - 1 Or _
                      Word.LastIndexOf(",") = Word.Length - 1 Then
                 Word = Word.Substring(0, Word.Length - 1)
              End If
              If HasWord(Word, WordDetailList) Then
                UpdateWordDetail(Word, WordDetailList)
              Else
                AddWordDetail(Word, WordDetailList)
              End If
              NotFound = False
            Else
              CurrentIndex = CurrentIndex + 1
            End If
          End While
        End If
      End While
    End If
  Next f

  Dim AutoIndexSet As XDocument = _
    <?xml version="1.0" encoding="utf-8"?>
    <CatapultAutoIndexSet></CatapultAutoIndexSet>

  SortWordDetailListByFrequency(WordDetailList)

  For Each wd In WordDetailList
    Try
      If wd.Word IsNot Nothing Then
        AutoIndexSet.Root.Add(
          <AutoIndex Phrase=<%= wd.Word.ToString %> 
          IndexTerm=<%= wd.Word.ToString %>/>)
      End If
    Catch ex As Exception

    End Try
  Next

  AutoIndexSet.Save(AutoIndexSetFilePath)
End Sub
End Module
